#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef vector<int> vi;

#define N 100007

int c[N];
int d[N];

int nije_nzd(int a, int k) {
    int proizvod = 1;
    for (int i = 1; i < k; i++) {
        if (a % c[i] == 0) {
            proizvod = proizvod ^ c[i];
        }
    }
    return proizvod;
}

int main() {
    ios::sync_with_stdio(true);
    cin.tie(0);

    unordered_map<int, int> erej;

    ll n;
    int k;
    cin >> n >> k;

    for (int i = 0; i < k; i++) {
        cin >> d[i];
        c[i] = d[i];
    }

    sort(c, c+k);

    for (int i = 0; i < k; i++) {
        erej[c[i]] = nije_nzd(c[i], k);
    }
    for (int i = 0; i < k; i++) {
        cout << erej[d[i]] << ' ';
    }

}